
package de.ivu.elect.business.wahlvorschlag.boundary;

import javax.inject.Inject;

import de.ivu.elect.business.wahlvorschlag.entity.Liste;

// abgeleitete Klasse mit "@javax.ejb.Stateless" annotieren!
public abstract class AbstractListeEdit {

  @Inject
  protected ListeDAO dao;

  @Inject
  protected ListeExtendedDAO extendedDao;

  public void delete(Liste entity) {
    dao.remove(getAttachedEntity(entity));
  }

  public void save(Liste entity) {
    validate(entity);

    flushToSave();
  }

  protected void validate(Liste entity) {
    // Do nothing by default.
  }

  protected void flushToSave() {
    if(usesMixedTransactionalContexts()) {
        extendedDao.flushNewTransaction();
    } else {
        extendedDao.flush();
    }
  }

  // ELECT-945
  protected boolean usesMixedTransactionalContexts() {
    return false;
  }

  protected Liste getAttachedEntity(Liste entity) {
    return dao.findByPrimaryKey(entity.getPk());
  }

  // Cf. ELECT-3187 (Änderungen an Entität werden nicht gespeichert)
  protected Liste getAttachedAndRefreshedEntity(Liste entity) {
    return dao.refresh(entity);
  }
}
